;************************
;* SOMETHING TO DO GAME.*
;*       BY XAVSNAP     *
;************************

@DECODE=07BD
@DEST=+16402
@DFILE=+16396
@FAST=2D6
@FRAMES=+16436
@SEED=+16434
@SLOW=2BF
@CLS=A2A
@KEYLOW=+16421
@KEYHI=+16422
@NXTL= 4029
@EXTERR=005B
@TEMP8=4020
@KEYB=02BB
@DFZCC=400E

ORG +16514

"34X24" 76 76
;************************
; OLD DF
@OLDDF   ; 16521
00 00 

@NEWDF   ; 16523
00 00
;************************

@INIT
LD HL,(DFILE)
LD (OLDDF),HL

LD HL,(DEST)
LD BC,21
ADD HL,BC
LD A, 76
LD (HL),A
LD (DFILE),HL
LD (NEWDF),HL
JP RETBAS

@END
LD HL,(OLDDF)
LD (DFILE),HL
RET

@START
LD HL,(OLDDF)
LD DE,(NEWDF)
SBC HL,DE
RET P
LD (DFILE),DE
RET

@CLS
LD HL,(NEWDF)
LD A, 0
LD C,+24

@RET0
LD B,+34
@RET1
INC HL
LD (HL),A
DJNZ RET1
DEC C
JR NZ RET0
RET

@SCROLLL
CALL SCROLL1
JP RETBAS

;SCOLL UP
@SCROLL1
LD HL,(NEWDF)
INC HL
LD BC,+34
ADD HL,BC
LD D,H
LD E,L
SBC HL,BC
EX DE,HL
LD BC,+782
LDIR
EX DE,HL
LD B,+34
LD A,0
@RETSCR1
LD (HL),A
INC HL
DJNZ RETSCR1
RET

@SCROLLA
LD B,+24
@RETSCR2
PUSH BC
CALL SCROLL1
POP BC
DJNZ RETSCR2
JP RETBAS

@XORS
LD HL,(NEWDF)
LD C,+24

@RET2
LD B,+34
@RET3
INC HL
LD A, (HL)
XOR +128
LD (HL),A
DJNZ RET3
DEC C
JR NZ RET2
RET

@XORL
LD HL,(DEST)
LD B,+34
@RET4
LD A, (HL)
XOR +128
LD (HL),A
INC HL
DJNZ RET4
JP RETBAS

;GL offset
;
;SCROLLING EXAMPLE 
;<-

LD HL,(NEWDF)
LD D,H
LD E,L
INC HL
EXX
LD B,+24
@RET5  
EXX
INC DE
INC HL
LD BC,+33
LD A,(DE)
;HL -> DE
;BC=BC+1
LDIR
LD (DE),A
EXX
DJNZ RET5
EXX
RET

;->

LD HL,(NEWDF)
LD D,H
LD E,L
INC DE
EXX

LD B,+24
@RET6  
EXX
LD DE,+33
ADD HL,DE
LD D,H
LD E,L
INC DE
LD BC,+33
LD A,(DE)
;HL -> DE
;BC=BC-1
LDDR
LD (DE),A
LD DE,+34
ADD HL,DE
EXX
DJNZ RET6
EXX
RET

@RLL
LD HL,(DEST)
LD D,H
LD E,L
DEC DE
EXX
LD B,1
CALL RET5
JR RETBAS

@RRL
LD HL,(DEST)
DEC HL
LD D,H
LD E,L
INC DE
EXX
LD B,1
CALL RET6

@RETBAS
JP EXTERR

;@PICT

@DISPLAY
LD HL,(DEST)
LD DE,(407B)
LD C,+16
@NXTLD
LD B,+12

@DCONT
LD A,(DE)
RR A
RR A
RR A
RR A
CALL DISPC
LD A,(DE)
CALL DISPC
INC DE
DJNZ DCONT
DEC C
JP Z ENDDISP

LD (407B),DE
LD DE,+10
ADD HL,DE
LD DE,(407B)

JR NXTLD

@ENDDISP
JR RETBAS

@DISPC
AND +15
SUB +8
JP M DISP1
ADD A,+120
@DISP1
ADD A,+8
LD (HL),A
INC HL
RET

LD BC,(TEMP8)
LD HL,4221
LD DE,+192
SBC HL,DE
@NBADD
ADD HL,DE
DJNZ NBADD
LD (407B),HL
JR DISPLAY

@KBINP
LD HL,(DEST)
LD E,(HL)    
LD A,(HL)
LD (DFZCC),HL

@KBRET0
PUSH AF      
PUSH HL      
CALL KEYB; [KEYBOARD]
LD B,H       
LD C,L       
POP HL       
POP AF
LD HL,(DFZCC)       
XOR 80    
LD (HL),A    
LD D,C       
INC D
JR Z KBRET0
    
LD (HL),E    
CALL DECODE
LD A,(HL)
CP 76
JR Z EXITKB
CP 77
JR Z DCAR

LD HL,(DFZCC)
AND +127
LD (HL),A
INC HL
LD (DFZCC),HL

@RETP   
LD D,A       
XOR 80    
LD BC,1B58  
@KBRET1    
DEC BC       
LD A,B       
OR C       
JR NZ KBRET1 
;LD (HL),D 
JR KBRET0

@DCAR
LD HL,(DFZCC)
LD A,0
LD (HL),A
DEC HL
LD (DFZCC),HL
JR RETP
    
@EXITKB
LD HL,(DFZCC)
LD A,0
LD (HL),A
JP EXTERR


